/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * <p>
 * http://www.apache.org/licenses/LICENSE-2.0
 * <p>
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.qlangtech.tis.manage.common;

import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpServletResponseWrapper;
import java.io.IOException;
import java.io.PrintWriter;

/**
 * @author: 百岁（baisui@qlangtech.com）
 * @create: 2023-12-24 11:32
 **/
public class TISHttpServletResponseWrapper extends HttpServletResponseWrapper {
  private boolean hasSetContentType = false;

  public TISHttpServletResponseWrapper(HttpServletResponse response) {
    super(response);
  }

  @Override
  public void setContentType(String type) {
    if (!this.hasSetContentType) {
      super.setContentType(type);
      this.hasSetContentType = true;
    }
  }

  @Override
  public PrintWriter getWriter() throws IOException {
    return super.getWriter();
  }
}
